# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from monkeywrench/TriggerErrorRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class TriggerErrorRequest(genpy.Message):
  _md5sum = "75341b138df1c4283d81eca1828b1378"
  _type = "monkeywrench/TriggerErrorRequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """uint8 failure_mode
uint8 FAIL_STOP_SENDING=1
uint8 FAIL_USE_CONSTANT=2
uint8 FAIL_SEND_GAUSSIAN_NOISE=4
uint8 FAIL_SEND_UNIFORM_NOISE=8
uint8 FAIL_CHANGETIME=16

float32 constant
float32 noise_std_dev
float32 time_change

float32 duration

string[] apply_to_subtopics
"""
  # Pseudo-constants
  FAIL_STOP_SENDING = 1
  FAIL_USE_CONSTANT = 2
  FAIL_SEND_GAUSSIAN_NOISE = 4
  FAIL_SEND_UNIFORM_NOISE = 8
  FAIL_CHANGETIME = 16

  __slots__ = ['failure_mode','constant','noise_std_dev','time_change','duration','apply_to_subtopics']
  _slot_types = ['uint8','float32','float32','float32','float32','string[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       failure_mode,constant,noise_std_dev,time_change,duration,apply_to_subtopics

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(TriggerErrorRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.failure_mode is None:
        self.failure_mode = 0
      if self.constant is None:
        self.constant = 0.
      if self.noise_std_dev is None:
        self.noise_std_dev = 0.
      if self.time_change is None:
        self.time_change = 0.
      if self.duration is None:
        self.duration = 0.
      if self.apply_to_subtopics is None:
        self.apply_to_subtopics = []
    else:
      self.failure_mode = 0
      self.constant = 0.
      self.noise_std_dev = 0.
      self.time_change = 0.
      self.duration = 0.
      self.apply_to_subtopics = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_B4f().pack(_x.failure_mode, _x.constant, _x.noise_std_dev, _x.time_change, _x.duration))
      length = len(self.apply_to_subtopics)
      buff.write(_struct_I.pack(length))
      for val1 in self.apply_to_subtopics:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 17
      (_x.failure_mode, _x.constant, _x.noise_std_dev, _x.time_change, _x.duration,) = _get_struct_B4f().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.apply_to_subtopics = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.apply_to_subtopics.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_B4f().pack(_x.failure_mode, _x.constant, _x.noise_std_dev, _x.time_change, _x.duration))
      length = len(self.apply_to_subtopics)
      buff.write(_struct_I.pack(length))
      for val1 in self.apply_to_subtopics:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 17
      (_x.failure_mode, _x.constant, _x.noise_std_dev, _x.time_change, _x.duration,) = _get_struct_B4f().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.apply_to_subtopics = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.apply_to_subtopics.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B4f = None
def _get_struct_B4f():
    global _struct_B4f
    if _struct_B4f is None:
        _struct_B4f = struct.Struct("<B4f")
    return _struct_B4f
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from monkeywrench/TriggerErrorResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class TriggerErrorResponse(genpy.Message):
  _md5sum = "003b81baa95ab323fc1ddf3c7d0bee81"
  _type = "monkeywrench/TriggerErrorResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """bool response

"""
  __slots__ = ['response']
  _slot_types = ['bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       response

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(TriggerErrorResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.response is None:
        self.response = False
    else:
      self.response = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.response
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.response,) = _get_struct_B().unpack(str[start:end])
      self.response = bool(self.response)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.response
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.response,) = _get_struct_B().unpack(str[start:end])
      self.response = bool(self.response)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
class TriggerError(object):
  _type          = 'monkeywrench/TriggerError'
  _md5sum = 'eaadd1c5fe9addece0ebb5a4b467316f'
  _request_class  = TriggerErrorRequest
  _response_class = TriggerErrorResponse
